routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });
Route::get('/', 'Auth\LoginController@showLoginForm');
Auth::routes();

Route::group(['middleware' => ['auth']], function() {
	Route::get('/home', 'HomeController@index')->name('home');

	Route::resource('/users', 'UserController');
	Route::resource('/measurements', 'MeasurementController');
    Route::resource('/variants', 'VariantController');
    Route::resource('/attributes', 'AttributeController');
	Route::resource('/brands', 'BrandController');
    Route::resource('/categories', 'CategoryController');
    Route::resource('/countries', 'CountryController');
    Route::resource('/products', 'ProductController');
    Route::resource('/options', 'OptionController');

    Route::delete('/deleteproducts', 'ProductController@deleteMultipleProducts')->name('products.multipledelete');
    Route::resource('/orders', 'OrderController');
    Route::get('/print/{id}', 'OrderController@printPreview')->name('orders.print');
    Route::post('/orders/updatestatus', 'OrderController@changeStatus')->name('orders.updatestatus');
    Route::get('/customers', 'UserController@customers')->name('users.customers');

    Route::post('/variantoptions', 'VariantController@getVariantOptions')->name('variant.options');
    Route::post('/fetchattributes', 'MeasurementController@getAttributes')->name('measurement.attributes');

    Route::post('customer/status', 'UserController@changeStatus')->name('user.updatestatus');

    Route::delete('/deletebanners', 'OptionController@deleteBanners')->name('option.bannerdelete');
});

//Route::get('admin/home', 'HomeController@adminHome')->name('admin.home')->middleware('is_admin');

Route::get('/clear-cache', function() {
    Artisan::call('cache:clear');
    Artisan::call('route:clear');
    Artisan::call('config:clear');
    Artisan::call('view:clear');
    // return "Cache is cleared";
    return view('cache');
})->name('cache.clear');

app/Order.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    //
    protected $fillable = [
        'id',
        'comment',
        'order_status_id',
        'address_id',
        'phone_id',
        'email_id',
        'user_id',
        'created_by_user_id',
        'updated_by_user_id'
    ];
}

app/Http/Controllers/Api/OrderController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Support\Str;
use Illuminate\Http\Request;
use App\Order;
use App\ProductOrder;
use App\OrderChangelog;
use App\User;
use Validator,Response;
use DB;
use Carbon\Carbon;
use Mail;
use Config;
use App\Product;
//use App\Events\NewOrders;
//use App\Jobs\SendEmailJob;

class OrderController extends Controller
{
    //
    public $MAIL_FROM;
    public $MAIL_FROM_NAME;

    public $WEB_URL;
    public $APP_URL;

    public $site_settings = [];

    public function __construct(){

        $this->MAIL_FROM = Config::get('mail.from.address');
        $this->MAIL_FROM_NAME = Config::get('mail.from.name');

        $this->APP_URL = Config::get('app.url');
        $this->WEB_URL = Config::get('app.web_url');

        $this->site_settings = ['tax_amount' => 5, 'min_limit' => 100];
    }

    protected function getLastID(){
        $lastRecord = DB::table('orders')->orderBy('id', 'DESC')->first();
        $inv_no = $lastRecord ? $lastRecord->id : 0;

        return (int) $inv_no;
    }

    protected function priceCalculate($products){

        if(!empty($products)){
            $sub_total = 0;

            foreach ($products as $key => $value) {

                $prod_data  = Product::find($value['id']);
                $price = $prod_data->price;
                $total = $price * $value['count'];
                // PRODUCTS
                $products[$key]['price'] = $price;
                $products[$key]['total'] = $total;
                $sub_total += $total;
            }

            return ['sub_total' => $sub_total, 'products' => $products];
        }
    }  

    // public function createUser($request){
    //     // register user details 
    //     $user_data =  ['fullname'   => implode(' ',[$request->firstname, $request->lastname]),
    //                    'email'  => $request->email,
    //                    'phone'  => $request->phone,
    //                    'username' => $request->username,
    //                    'password' => $request->password,
    //                    'password_confirmation' => $request->password
    //                 ];


    //     $ures =  app(JWTAuthController::class)->register($user_data);
    //     $userRes = json_decode($ures);

    //     return $userRes;
    // }  
    public function createUser($request){

        $validator = Validator::make($request->all(), [     
            'username'   => 'required|string|between:4,15|unique:users',
            'password'   => 'required|confirmed|string|min:6'
        ]);

        if ($validator->fails())
        {
            return ['status'=> false,'errors'=>$validator->errors()->all()];
        }
        if(isset($request->email) && $request->email){
            $isemail = DB::table('emails')->where('email','=', $request->email)->count();

            if($isemail > 0){
                return ['status'=> false,'errors'=> ['Email already exists']];
            }
        }
        if(isset($request->phone) && $request->phone){
            $isphone = DB::table('phones')->where('number','=', $request->phone)->count();

            if($isphone > 0){
                return ['status'=> false,'errors'=> ['Phone number already exists']];
            }
        }

        $user_last = User::orderBy('id', 'desc')->first();
        $lastid = $user_last->id;

        $data = ['id'         => (int) $lastid + 1,
                'first_name'  => $request->firstname,
                'last_name'   => $request->lastname,
                'username'    => $request->username,         
                'password'    => sha1($request->password),
                'birthday'    => null,
                'is_blocked'  => false,
                'facebook_id' => null,
                'firebase_id' => null,
                'google_id'   => null,
                'default_address_id' => null,
                'default_email_id' => null,
                'default_phone_id' => null,
                'role_id'     => 1
                ];

        $userid = DB::table('users')->insertGetId($data);

        // Insert email
        if(isset($request->email) && $request->email){
            $email_last = DB::table('emails')->orderBy('id', 'desc')->first();            
            $email_last_id = $email_last->id;

            $code = (string) Str::uuid();

            DB::table('emails')->insert([
                    'id'        => (int) $email_last_id + 1,
                    'email'     => $request->email,
                    'approved'  => false,
                    'code'      => $code,
                    'user_id'   => $userid
                ]);  
       }

        // Insert phone
        if(isset($request->phone) && $request->phone){
            $phone_last = DB::table('phones')->orderBy('id', 'desc')->first();
            $phone_last_id = $phone_last->id;

            DB::table('phones')->insert([
                    'id'        => (int) $phone_last_id + 1, 
                    'number'     => $request->phone,
                    'approved'  => false,
                    'user_id'   => $userid,
                    'country_id'=> 234 // UAE
                ]);  
        }

        $user = User::find($userid);
        $user_email = DB::table('emails')->where('user_id', '=', $user->id)->first();
        $user->email = $user_email->email;

        $user_phones = DB::table('phones')->where('user_id', '=', $user->id)->first();
        $user->phone = $user_phones->number;

        return ['status' => true, 'data' => $user];
    }

    public function emailID($request, $userid){
        return DB::table('emails')
                ->where('user_id', '=', $userid)
                ->where('email','=', $request->email)
                ->first();
    }
    
    public function phoneID($request, $userid){
        return DB::table('phones')
                ->where('user_id', '=', $userid)
                ->where('number','=', $request->phone)
                ->first();
    }

    public function insertAddress($request, $userid){
        $addressid = 0;

        if(!$request->address_id){

            $last_row = DB::table('addresses')->orderBy('id','desc')->first();
            $lastid = $last_row->id;

            $data = [
                'id'        => $lastid + 1,
                'zip'       => null,
                'region'    => $request->area,
                'city'      => $request->city,
                'line1'     => $request->address,
                'line2'     => null,
                'user_id'   => $userid,
                'created_at'   => \Carbon\Carbon::now(),
                'updated_at'   => \Carbon\Carbon::now(),
                'country_id'   => 234
            ];
            $addressid = DB::table('addresses')->insertGetId($data);

            return $addressid;
        }
    }

    public function createOrder(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'firstname' => 'required|string',
            'lastname'  => 'required|string',
            'email'     => 'required|email',
            'phone'     => 'required|min:10',
            'address'   => 'required'
        ]);
       
        if ($validator->fails())
        {
            return response()->json(['status'=> false, 'errors' => $validator->errors()->all()], 422);
        }
        $min_limit = $this->site_settings['min_limit'];
        if($request->total_amount < $min_limit){
            return response()->json(['status'=> false, 'errors' => 'You must order amount above '.$min_limit.' AED'], 422);
        }
        //Price Calcuation
        $prodz = json_decode($request->products, true);

        if(empty($prodz)){
            return response()->json(['status'=> false, 'errors' => 'Products are empty'], 422);   
        }

        ## USER
        $userid = 0;
        if(!$request->user_id){
            // user create
            $user_info = $this->createUser($request);

            if(isset($user_info['status']) && !$user_info['status']){
                return response()->json($user_info, 422);
            }else{
               // return response()->json($user_info, 200);
                $userid = $user_info['data']->id;
            }           
        }else{
            $userid = $request->user_id? $request->user_id : 0;
        }


        ## email
        $emailid = 0;
        $email_row = $this->emailID($request, $userid);
        if(!$email_row){
            // email create
        }else{
            $emailid = $email_row->id;
        }

        ## phone
        $phoneid = 0;
        $phone_row = $this->phoneID($request, $userid);
        if(!$phone_row){
            // email create
        }else{
            $phoneid = $phone_row->id;
        }
        
        ## ADDRESS
        $addressid = 0;
        if(!$request->address_id){
            // user address create 
            $addressid = $this->insertAddress($request, $userid);
        }else{
            $addressid = $request->address_id? $request->address_id : 0;
        }  


        ## Products and its price 
        $cal_res    = $this->priceCalculate($prodz);

        $products   = $cal_res['products'];
        $sub_total  = $cal_res['sub_total'];
        $vat_amt    = 0; 
        $total_amount = 0;
        $delivery   = $request->delivery;// 5AED for delivery

        ## VAT 
        $vat_amt = $sub_total * ($this->site_settings['tax_amount']/100);
        $total_amount = $vat_amt + $sub_total + $delivery;
      
        // CREATE ORDER       
        $last_ord_id = $this->getLastID();       

        $oInsert = [
            'id'            => $last_ord_id + 1,
            'comment'       => $request->comments,
            'order_status_id' => 1,   
            'address_id'    => $addressid,
            'phone_id'      => $phoneid,
            'email_id'      => $emailid,
            'user_id'       => $userid,
            'created_by_user_id' => $userid,

resources/views/orders/index.blade.php
@extends('layouts.admin')


@section('content')
<!-- Content Header (Page header) -->
<section class="content-header">
  <div class="container-fluid">
    <div class="row mb-2">
      <div class="col-sm-6">
        <h1>Orders</h1>
      </div>
      <div class="col-sm-6">
        <ol class="breadcrumb float-sm-right">
          <li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
          <li class="breadcrumb-item active">Orders</li>
        </ol>
      </div>
    </div>
  </div><!-- /.container-fluid -->
</section>

<!-- Main content -->
<section class="content">
  <div class="container-fluid">
    <div class="row">
      <div class="col">

        <div class="card">
        <div class="card-header">
          <h3 class="card-title">Manage Orders</h3>                  
        </div>
        <!-- /.card-header -->
        <div class="card-body">
          @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
          @endif          
          <table id="order-tbl" class="table table-bordered table-hover">
            <thead>
            <tr>
              <th>#</th>
              <th>Name</th>
              <th>Status</th>
              <th>Comment</th>                        
              <th>Created at</th>              
              <th>Action</th>                  
            </tr>
            </thead>
            <tbody id="order-new"> 
             @foreach ($orders as $key => $order)
              @php
                $time = strtotime($order->created_at) + 60*60*4;
              @endphp 
              <tr>
                <td>{{ $order->id }}</td>
                <td>{{ $order->first_name.' '.$order->last_name }}</td>
                <td><span class="badge badge-danger">{{$order->status}}</span>
                </td> 
                <td>{{ $order->comment }}</td>                
                <td>{{ date("d-m-Y H:i:s", $time) }}</td>                            
                <td>             
                   <a href="{{route('orders.print', $order->id)}}" target="_blank" title="Print Preview" class="btn btn-info mr-2"><i class="fas fa-print"></i></a>

                   <a class="btn btn-warning mr-2" href="{{ route('orders.show',$order->id) }}" title="View"><i class="fas fa-eye"></i></a>  
                  {!! Form::open(['method' => 'DELETE','route' => ['orders.destroy', $order->id],'style'=>'display:inline']) !!}
                    <button type="submit" class="btn btn-danger" title="Delete" onclick="return confirmDel('{{ $order->id }}' );"><i class="fas fa-trash"></i></button>
                  {!! Form::close() !!}           
                </td>
              </tr>
             @endforeach 
            </tbody>
            <tfoot>
            <tr>
              <th>#</th>
              <th>Name</th>
              <th>Status</th>
              <th>Comment</th>                        
              <th>Created at</th>              
              <th>Action</th>                     
            </tr>
            </tfoot>
          </table>
        </div>
        <!-- /.card-body -->
        </div>
        <!-- /.card -->
      </div>
      <!-- <div class="col">&nbsp;</div> -->
    </div>
  </div>
</section> 
<!-- /.content -->
<script type="text/javascript">
function confirmDel(name){
  if(confirm('Are you sure to delete the order of #'+name+' ?')){
    return true;
  }else{
    return false;
  }
}
</script>
@endsection

resources/views/orders/show.blade.php
@extends('layouts.admin')


@section('content')
<!-- Content Header (Page header) -->
<section class="content-header">
  <div class="container-fluid">
    <div class="row mb-2">
      <div class="col-sm-6">
        <h1>Order Summary</h1>
      </div>
      <div class="col-sm-6">
        <ol class="breadcrumb float-sm-right">
          <li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
          <li class="breadcrumb-item active">View Order</li>
        </ol>
      </div>
    </div>
  </div><!-- /.container-fluid -->
</section>
  <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <div class="callout callout-info">
              <h5><i class="fas fa-info"></i> Note:</h5>
              Please check the order details and update status of it.
              @if ($message = Session::get('success'))
                <div class="alert alert-success">
                    <p>{{ $message }}</p>
                </div>
              @endif 
            </div>
            @php
                $time = strtotime($order->created_at) + 60*60*4;
            @endphp 
            <!-- Main content -->
            <div class="invoice p-3 mb-3">
              <!-- title row -->
              <div class="row">
                <div class="col-12">
                  <h4>
                    <i class="fas fa-globe"></i> Menu4u
                    <small class="float-right">Date: {{date("d-m-Y H:i:s", $time)}}</small>
                  </h4>
                </div>
                <!-- /.col -->
              </div>
              <!-- info row -->
              <div class="row invoice-info">
                <div class="col-sm-4 invoice-col">
                  From
                  <address>
                    <strong>{{$order->first_name.' '.$order->last_name}}</strong><br>
                    @if($address)
                      {{$address->line1}}, {{$address->line2}}<br>
                      {{$address->city}}, {{$address->region}}, {{$address->zip}}<br>
                    @endif
                    @if($phones)
                      Phone:  {{$phones->number}}<br>
                    @endif
                    @if($emails)
                      Email:  {{$emails->email}}
                    @endif
                  </address>
                </div>
                <!-- /.col -->
                <div class="col-sm-4 invoice-col">
                 
                </div>
                <!-- /.col -->
                <div class="col-sm-4 invoice-col">                 
                  <b>Order ID:</b> {{$order->id}}<br>
                  <b>Payment:</b> Cash On Delivery<br>
                  <b>Delivery Type:</b> Shipping<br>
                  <b>Comments:</b> {{$order->comment}}
                  <br/>
                </div>
                <!-- /.col -->
              </div>
              <!-- /.row -->
              @if(count($products) == 0)
              <div class="row">
                <div class="col-12">
                  <p class="text-muted text-center">  No Products Found</p>
                </div>
              </div>
              @else
              <!-- Table row -->
              <div class="row">
                <div class="col-12 table-responsive">
                  <table class="table table-striped">
                    <thead>
                    <tr>
                      <th>Qty</th>
                      <th>Product</th>                     
                      <th>Subtotal</th>
                    </tr>
                    </thead>
                    <tbody>
                      @php
                        $sub_total = 0;
                      @endphp                     
                      @foreach($products as $row)
                      @php
                        $item_total = ($row->quantity * $row->price);
                        $sub_total += $item_total;
                      @endphp                     
                      <tr>
                        <td>{{$row->quantity}}</td>
                        <td>{{$row->name}}    
                        </td>                     
                        <td>AED {{$item_total}}</td>
                      </tr>
                     
                      @endforeach  
                              
                    </tbody>
                  </table>
                </div>
                <!-- /.col -->
              </div>
              <!-- /.row -->

              <div class="row">
                <!-- accepted payments column -->
                <div class="col-6">
                 <!--  <p class="lead">Payment Methods:</p>
                  <img src="../../dist/img/credit/visa.png" alt="Visa">
                  <img src="../../dist/img/credit/mastercard.png" alt="Mastercard">
                  <img src="../../dist/img/credit/american-express.png" alt="American Express">
                  <img src="../../dist/img/credit/paypal2.png" alt="Paypal">

                  <p class="text-muted well well-sm shadow-none" style="margin-top: 10px;">
                    Etsy doostang zoodles disqus groupon greplin oooj voxy zoodles, weebly ning heekya handango imeem
                    plugg
                    dopplr jibjab, movity jajah plickers sifteo edmodo ifttt zimbra.
                  </p> -->
                </div>
                <!-- /.col -->
                <div class="col-6">                  
                  <div class="table-responsive">
                    <table class="table">
                      <tr>
                        <th style="width:50%">Price</th>
                        <td>AED {{$sub_total}}</td>
                      </tr>                      
                      <tr>
                        <th>VAT (5%)</th>
                        <td>
                        @php
                          $vat_price = $sub_total * 0.05;
                        @endphp  

                        AED {{$vat_price}}</td>
                      </tr>
                     
                      <tr>
                        <th>Delivery Charge</th>
                        <td>FREE</td>
                      </tr>
                      <tr>
                        <th>Total</th>
                        <td>AED {{$sub_total + $vat_price}}</td>
                      </tr>
                    </table>
                  </div>
                </div>
                <!-- /.col -->
              </div>
               @endif      

              <!-- this row will not appear when printing -->
              <div class="row no-print">
                <div class="col-12">
                 
                  <!-- <button type="button" class="btn btn-success float-right"><i class="far fa-credit-card"></i> Submit
                    Payment
                  </button>
                  <button type="button" class="btn btn-primary float-right" style="margin-right: 5px;">
                    <i class="fas fa-download"></i> Generate PDF
                  </button> -->
                </div>
              </div>
            </div>
            <!-- /.invoice -->
              <!-- /.row -->
              <div class="row">
                <!-- accepted payments column -->
                <div class="col-12">
                  <div class="card card-primary card-outline card-outline-tabs">     
                    <div class="card-header">
                      <h4>Update Order Status</h4>
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body">
                    <div class="row">
                    <div class="col-6"> 
                    {!! Form::open(array('route' => 'orders.updatestatus','method'=>'POST', 'autocomplete' => 'off' )) !!}

                      @if (count($errors) > 0)
                        <div class="alert alert-danger">
                            <strong>Whoops!</strong> There were some problems with your input.<br><br>
                            <ul>
                               @foreach ($errors->all() as $error)
                                 <li>{{ $error }}</li>
                               @endforeach
                            </ul>
                        </div>
                        @endif
                      <input type="hidden" name="order_id" value="{{$order->id}}">
                      <div class="form-group">
                        <label for="order_status_id">Status</label>
                        <select class="form-control" name="order_status_id" id="order_status_id">   
                          <option value="">-- Select --</option>                
                            @foreach ($status_lists as $id => $name)
                              <option value="{{$id}}" {{$id == $order->order_status_id? 'selected': ''}}>{{$name}}</option> 
                            @endforeach
                        </select>
                      </div>
                      <div class="form-group">
                        <label for="comments">Comments</label>                     
                        {!! Form::textarea('comments', null, ['placeholder' => 'If any comments, please enter','class' => 'form-control','id' => 'comments', 'rows' => 4, 'cols' => 10]) !!}
                      </div>

                      <button type="submit" class="btn btn-primary">Submit</button>

                    {!! Form::close() !!}
                  </div>
                    <div class="col-6"> 
                    <div class="table-responsive">
                      <table class="table">
                        <tr>
                          <th>Status</th>   
                          <th style="width:50%">Comments</th>                                     
                          <th>Date On</th>                       
                        </tr>
                        @if(count($history) == 0)
                          <tr>
                          <td colspan="3"><p class="text-muted text-center">No Data</p></td>
                          </tr>
                        @endif
                        @foreach($history as $his)
                          @php
                            $time = strtotime($his->created_at) + 60*60*4;
                          @endphp 
                        <tr>
                          <td>{{$his->status_name}}</td>
                          <td>{{$his->status}}</td>
                          <td>{{date("d-m-Y H:i:s", $time)}}</td>
                        </tr> 
                        @endforeach
                                
                      </table>
                    </div>
                  </div>
                  </div><!-- row -->
                </div>
                  <div class="card-footer">                      
                      <a class="btn btn-secondary float-right" href="{{ route('orders.index') }}"> Back</a>                      
                    </div>
                  </div>
                </div>
              
              </div>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>


@endsection